#!/usr/bin/perl
# This takes a series of tab files describing transcripts strutures and counts and a list of where ORFS and features are
# it then tracks them in a time course and also tries to let you know what transcript has what ORFS
# name_transcripts_and_track_ssc.pl prefix ssc_nt features_table.txt genome.fasta start_sad_polya_pattern_count.txt1 
#
#ssc_nt is how many nucleotides you want translation to start upstream of the apparent TSS to compensate for the loss of 5' information, for adeno we use 10
#

$prefix = $ARGV[0]."_ssc";
$ssc = $ARGV[1];
$command_line = join (' ', @ARGV);
open(INFEATURES, "$ARGV[2]"); # opens features you program in
open(INFASTA, "$ARGV[3]"); #open genomne
open(INCOUNT, "$ARGV[4]"); #open start sad stop count table
$current_count = 4;
$max_files = scalar @ARGV;
$max_files --;
open (OUTC, ">$prefix.proteins_known.fasta");
open (OUTD, ">$prefix.proteins_not_known.fasta");
open (OUTSPLICESAD, ">$prefix.splice_acceptor_donor_usage.txt");
#open (OUTKOZAC, ">$prefix.kozac_list.txt");
open (OUTTRANS, ">test_transcripts.fasta");
open (OUTTSS, ">$prefix.TSS_start_sad_polyA_count_list.txt");

%for_translation = (TTT=>"F", TTC=>"F", TCT=>"S", TCC=>"S", TAT=>"Y", TAC=>"Y", TGT=>"C", TGC=>"C", TTA=>"L", TCA=>"S", TAA=>"*", TGA=>"*", TTG=>"L", TCG=>"S", TAG=>"*", TGG=>"W", CTT=>"L", CTC=>"L", CCT=>"P", CCC=>"P", CAT=>"H", CAC=>"H", CGT=>"R", CGC=>"R", CTA=>"L", CTG=>"L", CCA=>"P", CCG=>"P", CAA=>"Q", CAG=>"Q", CGA=>"R", CGG=>"R", ATT=>"I", ATC=>"I", ACT=>"T", ACC=>"T", AAT=>"N", AAC=>"N", AGT=>"S", AGC=>"S", ATA=>"I", ACA=>"T", AAA=>"K", AGA=>"R", ATG=>"M", ACG=>"T", AAG=>"K", AGG=>"R", GTT=>"V", GTC=>"V", GCT=>"A", GCC=>"A", GAT=>"D", GAC=>"D", GGT=>"G", GGC=>"G", GTA=>"V", GTG=>"V", GCA=>"A", GCG=>"A", GAA=>"E", GAG=>"E", GGA=>"G", GGG=>"G");
%rev_translation = (GGC=>"A", ACT=>"S", TCA=>"*", ACA=>"C", TCG=>"R", GAT=>"I", GTT=>"N", GCT=>"S", GTA=>"Y", TGT=>"T", CGA=>"S", CGG=>"P", CAG=>"L", TGC=>"A", CAC=>"V", CTT=>"K", AAC=>"V", GTG=>"H", TCT=>"R", GGT=>"T", TGG=>"P", CCA=>"W", GAG=>"L", GCG=>"R", CAA=>"L", TTA=>"*", CTG=>"Q", CGT=>"T", CAT=>"M", TTT=>"K", TAC=>"V", CTA=>"*", AAG=>"L", TCC=>"G", GAC=>"V", GCA=>"C", TGA=>"S", AAT=>"I", ATA=>"Y", ATT=>"N", AGT=>"T", TTG=>"Q", GTC=>"D", ACC=>"G", GGA=>"S", AAA=>"F", CCT=>"R", ACG=>"R", CCG=>"R", ATG=>"H", TAT=>"I", GGG=>"P", CCC=>"G", TAA=>"L", CTC=>"E", TAG=>"L", ATC=>"D", AGA=>"S", GAA=>"F", CGC=>"A", GCC=>"G", AGC=>"A", TTC=>"E", AGG=>"P");
%base_pair = (G=>"A", A=>"T", T=>"A", C=>"G");
print "hi\n";
%translate_now = %for_translation;
@features = ();
%splice_ad = ();
%fasta_file = ();
$fasta_out ="";
$fasta_header = "Not_started_yet";

while ($fasta_line = <INFASTA>)
{
    chomp $fasta_line;
    #print "\n$fasta_line\n";
    if (substr($fasta_line,0,1) eq ">") {
        substr($fasta_line,0,1) = "";
        if ($fasta_header ne "Not_started_yet") {
            $fasta_file{$fasta_header} = $fasta_out;
            
            #print "\n\n$fasta_header\n\n";
        }
        
        
        ($fasta_header, $tmp) = split (/\s/, $fasta_line, 2);
        
        
        $fasta_out ="";
    }
    else {$fasta_out = uc($fasta_out.$fasta_line);}
}

$fasta_file{$fasta_header} = $fasta_out;
print "$fasta_header\n$fasta_out\n";
if ($fasta_header eq "Not_started_yet") {print "Wrong command line\n"; exit;}

%features_proteins = ();
%features_proteins_count = ();
%features_polya_len = ();
%features_polya_dominant = ();
%features_names = ();
$count = 0;
while ($line = <INFEATURES>)
{
    chomp $line;
    $features[$count] = $line;
    
    #print "abc $line qqqq\n";
    if (index ($line, "STOP") == 0) {last;}
    @features_line = split(/\t/, $line);
    #0 has contig, 1 has strand, 2 has start, 3 has exons (if any), 4 has polya, 5 has the feature name and eventually 6 will have the sequence
    $contig = $features_line[0];
    $genome = $fasta_file{$contig};
    $strand = $features_line[1];
    $start = $features_line[2];
    $exons = $features_line[3];
    $polya = $features_line[4];
    $name = $features_line[5];
    @exon_array = split(/\s/, $exons);
    #push @exon_array, $polya;
    #unshift @exon_array, $start;
    if ($strand eq "+"){push @exon_array, $polya; unshift @exon_array, $start;} else {push @exon_array, $start; unshift @exon_array, $polya;}
    $feature_seq = "";
    $tmp = "";
    $exon_count = 0;
    while (scalar @exon_array > $exon_count){
        $start = $exon_array[$exon_count] - 1;
        $end = $exon_array[$exon_count + 1] - 1;
        if ($end-$start < 0) {print "$start xxx $end yyy $line\n"};
        $tmp = substr ($genome, $start, ($end-$start + 1));
        $feature_seq = $feature_seq.$tmp;

        #print "$feature_seq\n\n\n";

        $exon_count = $exon_count + 2;
    }
    
    $features_names{$name} = $feature_seq;
    $current_transcript = $feature_seq;
    if ($strand eq "-") {
        $rev_transcript = reverse($current_transcript);
        $rev_transcript =~ tr/ACGTacgt/TGCAtgca/;
        $current_transcript = $rev_transcript;
    }
    print OUTTRANS ">".$name."\n$current_transcript\n";
    $feature_translate = &translate(0);
   
    if (($new_peptide ne "") and ($stop eq "END")) {
        $features_proteins{$new_peptide} = $name;
        if (length $new_peptide > 4) {print OUTC ">"."$name\n"."$new_peptide\n";}
    }
    
    if (index ($name, "TSS") > 0){$tmp = $strand."\t".$start; $features_proteins{$tmp} = $name;}
    
    #print "$feature_seq\n\n\n";
    #$tmp = $line."\t".$feature_seq;
    $features[$count] = $line."\t".$feature_seq;
    #print "bbbbb $line hhhh\n zzzzz $features[$count] cccc\n";
    $count++;
}
$total_features = $count - 1;
#print "$total_features\n";
#print "$current_count aaa $max_files\n";
$t_line = "Contig\tStrand\tStart (including $ssc nt location correction)\tExons\tPolyA site End\tCount\tTranscript name\tAverage poly_A length\tStd deviation";
%gff_byorfname = ();
%gff_byorfname_count = ();
%kozac_list = ();
%orfs_printed = ();
@start_sad_polya_array = ();
%start_sad_polya_feature_list = ();
%start_sad_polya_hash = ();
%start_sad_polya_hash_count = ();
while ($current_count <= $max_files){
    
open(INCOUNT, "$ARGV[$current_count]"); #open start sad stop count table
    if ($current_count > 4) {$title = $title."Count\tTranscript_name\tPoly A len\tSD poly A len";}
    
while ($line = <INCOUNT>)
{
    chomp $line;
    $tss_out = $line;
    @count_line = split(/\t/, $line);
    #0 has contig, 1 has strand, 2 has start, 3 has exons (if any), 4 has polya, 5 has the count, 6 has a name, 7 has poly a len, 8 has SD for polyA
    $contig = $count_line[0];
    if (($contig eq "Contig") and ($current_count == 4)) {$title = $t_line."\tFeatures found\tFirst ORF found\tSecond ORF\tPrimary ORF\tTranscript (if ORF is not known)"; print OUTTSS "$line\n"; next;}
    if (($contig eq "Contig") and ($current_count > 4)) {$title = $title.$t_line."\tFeatures found\tFirst ORF found\tSecond ORF\tPrimary ORF\tTranscript (if ORF is not known)"; next;}
    $genome = $fasta_file{$contig};
    $strand = $count_line[1];
    $start = $count_line[2];
    if ($strand eq "+") {$start = $start - $ssc; if ($start < 1) {$start = 1;}}
    if ($strand eq "-") {$start = $start + $ssc; if ($start > length $genome) {$start = (length $genome) - 1;}}
    
    #if ($start <1){print "stopping   $line\n";exit;}
    $exons = $count_line[3];
    #print "$current_count xyz $exons   abcd \n";
    @exon_array = split(/\s/, $exons);
    @gff = @exon_array;
    $polya = $count_line[4];
    $start_sad_polya_coords =$contig."\t".$strand."\t".$start."\t".$exons."\t".$polya;
    $start_sad_polya_hash_count{$start_sad_polya_coords} = $start_sad_polya_hash_count{$start_sad_polya_coords}."+";
    $hash_count_len = length $start_sad_polya_hash_count{$start_sad_polya_coords};
    if ($hash_count_len < ($current_count - 3)) {
        $start_sad_polya_hash{$start_sad_polya_coords} = "."."\t"."."."\t"."."."\t"."X".$start_sad_polya_hash{$start_sad_polya_coords};
        $start_sad_polya_hash_count{$start_sad_polya_coords} = $start_sad_polya_hash_count{$start_sad_polya_coords}."+";
    }
    
    
    
    if (exists $start_sad_polya_hash{$start_sad_polya_coords}) {$start_sad_polya_hash{$start_sad_polya_coords} = $start_sad_polya_hash{$start_sad_polya_coords}."\t".$count_line[5]."\t".$count_line[6]."\t".$count_line[7]."\t".$count_line[8];
        ;} else {$start_sad_polya_hash{$start_sad_polya_coords} = $count_line[5]."\t".$count_line[6]."\t".$count_line[7]."\t".$count_line[8];}
    
    
    if ($strand eq "+"){push @exon_array, $polya; unshift @exon_array, $start;} else {push @exon_array, $start; unshift @exon_array, $polya;}
    
    $start_sad_polya_count = $count_line[5];
    $start_sad_polya_name = $count_line[6];
    $start_sad_polya_seq = "";
    $tmp = "";
    $eac = scalar @exon_array;
    $splice_pairs = "";
    #print "$current_count abc $eac\n";
    $exon_count = 0;
    $fail = 0;
    while (scalar @exon_array > $exon_count){
        $splice_donor_loc = $exon_array[$exon_count + 1];
        $splice_acceptor_loc = $exon_array[$exon_count + 2] - 1;
        $start = $exon_array[$exon_count] - 1;
        $end = $exon_array[$exon_count + 1] - 1;
         if (($start > $end) and ($current_count == 4)) {
            
             #print "$current_count $strand $exon_count abc $start xxx $end\n$line\n";
             $fail = -1;
            
        }
        $tmp = substr ($genome, $start, ($end-$start + 1));
        $splice_donor = substr ($genome, $splice_donor_loc, 2);
        $splice_acceptor = substr ($genome, ($splice_acceptor_loc - 2), 2);
        $start_sad_polya_seq = $start_sad_polya_seq.$tmp;
        $exon_count = $exon_count + 2;
        $sad_pair = $splice_donor."_".$splice_acceptor;
        if ($strand eq "-") {$rev_sp = reverse ($sad_pair);
            $rev_sp =~ tr/ACGTacgt/TGCAtgca/;
            $sad_pair = $rev_sp;}
        if ($splice_acceptor_loc > 0) {$splice_pairs = $splice_pairs.":".$splice_donor."_".$splice_acceptor; $splice_ad{$sad_pair} ++;}
    }
    #if ($fail < 0){print "@exon_array \n stopping second one   $line\n";exit;}
    if ($fail == -1) {next;}
    $new_peptide = "nothing!";
    $current_transcript = $start_sad_polya_seq;
    if ($strand eq "-") {
        $rev_transcript = reverse($current_transcript);
        $rev_transcript =~ tr/ACGTacgt/TGCAtgca/;
        $current_transcript = $rev_transcript;
        $rev_sp = reverse ($splice_pairs);
        $rev_sp =~ tr/ACGTacgt/TGCAtgca/;
        $splice_pairs = $rev_sp;
    }
    print OUTTRANS ">".$count_line[6]."\n$current_transcript\n";
    $orf = &translate(0);
    
    $second_orf = &translatesecond(0);
    $secondorf_found = "";
    if (exists $features_proteins{$second_orf}) {$secondorf_found = "Second initiating M codes for $features_proteins{$second_orf}";}
    if (exists $features_proteins{$orf}) {$orf_found = $features_proteins{$orf}; $orf_not_found = ""; $kozac_list{$orf_found} = $kozac;} else {
       
        $orf_found = "none from list"; $orf_not_found = $start_sad_polya_seq;
        if (exists $orfs_printed{$orf}) {$orfs_printed{$orf} ++;} else {print OUTD ">"."$count_line[6]"." coordinates are "."$start_sad_polya_coords\n"."$orf\n"; $orfs_printed{$orf} = 1;}
        #now to see if the protein tranlation is a truncation
        if (length $orf > 10) {
        foreach $key (keys %features_proteins){
            $name = $features_proteins{$key};
            if (index ($key, $orf) > 0) {$orf_found = "Possible 5' truncation of $name";}
            if (index ($key, $orf) == 0) {$orf_found = "Possible 3' truncation of $name";}
            if (index ($orf, $key) == 0) {$orf_found = "Possible 3' extension of $name";}
            if (index ($orf, $key) > 0) {$orf_found = "Possible 5' extension of $name";}
        }
        }
        if ((exists $features_proteins{$second_orf}) and ($orf_found eq "none from list")) {$orf_found = $features_proteins{$second_orf}."_2nd_M"; $orf_not_found = "";}
    }
    #OK we now have a sequence for the thing we have got counts on, we are not going to reverse this if its from the neg strand as we dont need to at this point
    #So now we go through the features table in order
    $count = 0;
    $endindex = index ($start_sad_polya_feature_list{$start_sad_polya_coords}, "END");
     if ($endindex < 0){
    while ($count <= $total_features){
        $line = $features[$count];
        #print "xxx  $line\n";
        $count ++;
        @features_line = split(/\t/, $line);
        if ($contig ne $features_line[0]) {next;}
        if ($strand ne $features_line[1]) {next;}
        $features_seq = $features_line[6];
        if (index ($features_line[5], "TSS") > 0) {
            # we have a start site feature, is our transcript within 50nt?
            $features_seq = "&";
            if ((($features_line[2] + 50) > $count_line[2] and (($features_line[2] - 50) < $count_line[2]))) {
                if (exists $start_sad_polya_feature_list{$start_sad_polya_coords}) {$start_sad_polya_feature_list{$start_sad_polya_coords} = $start_sad_polya_feature_list{$start_sad_polya_coords}.",".$features_line[5];} else {$start_sad_polya_feature_list{$start_sad_polya_coords} = $features_line[5];}
                # print "$start\n xxxx$line\n";
                print OUTTSS "$tss_out\n";
            }
                
            }
        
        #

        
        if (index ($start_sad_polya_seq, $features_seq) >= 0) {
            #print "ok\n";
            if (exists $start_sad_polya_feature_list{$start_sad_polya_coords}) {$start_sad_polya_feature_list{$start_sad_polya_coords} = $start_sad_polya_feature_list{$start_sad_polya_coords}.",".$features_line[5];} else {$start_sad_polya_feature_list{$start_sad_polya_coords} = $features_line[5];}
            }
    }
        }
    
    $features_proteins_count{$orf_found} =  $features_proteins_count{$orf_found} + $start_sad_polya_count;
    if (exists $start_sad_polya_feature_list{$start_sad_polya_coords}) {$final_features = $start_sad_polya_feature_list{$start_sad_polya_coords}; $start_sad_polya_feature_list{$start_sad_polya_coords} = $start_sad_polya_feature_list{$start_sad_polya_coords}." Splice acceptor/donors $splice_pairs END\t$orf_found\t$secondorf_found\t$orf\t$orf_not_found";} else {$final_features = "no features found";$start_sad_polya_feature_list{$start_sad_polya_coords} = "No features found. Splice acceptor/donors $splice_pairs END\t$orf_found\t$secondorf_found\t$orf\t$orf_not_found";}
    
    #
    #
    if ($strand eq "+") {$gff_start = $count_line[2]; $gff_end = $count_line[4] - 1;$gff_color = "0,0,0";} else {$gff_end = $count_line[2]; $gff_start = $count_line[4] - 1;$gff_color = "50,50,250";}
    #$gff_colorb = $gff_count/$max_reads;
    

    #if ($gff_colorb > 0.10) {$gff_color = "0,255,0";}
    # if ($gff_colorb > 0.3) {$gff_color = "255,150,150";}
    #if ($gff_colorb > 0.7) {$gff_color = "255,0,0";}
    $gff_id = $start_sad_polya_name;
    $pa_index = (index ($gff_id, "polyA_is_")) + 9;
   
    $pa_value = substr ($gff_id, $pa_index);
    
    if ($start_sad_polya_count > $features_polya_dominant{$orf_found}){
    $features_polya_len{$orf_found} = $pa_value;
    $features_polya_dominant{$orf_found} = $start_sad_polya_count;
    }
    
    
    if (exists $features_polya_average{$orf_found}) {$features_polya_average{$orf_found} = $features_polya_average{$orf_found}."\t".$pa_value;} else {$features_polya_average{$orf_found} = $pa_value;}
    #print "$gff_id\n$pa_value\n\n";
    $gff_transcript = "";
    $tmp_gff = "$contig\tnanopore\tmRNA\t$gff_start\t$gff_end\t.\t$strand\t.\tID=$gff_id;Count=$start_sad_polya_count;color=$gff_color;Features=$final_features;ORF=$orf_found;Splices=$splice_pairs\n";
    
    $exons = 1;
    $e_start = $gff_start;
    while (scalar @gff > 0){
        $exon_id = "exon_".$exons;
        $exons ++;
        $e_end = shift @gff;
        # 21 sept edit $e_end --;
        $tmp_gff = $tmp_gff."$contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id\n";
        $e_start = shift @gff;
    }
    #$exons ++;
    $exon_id = "exon".$exons;
    $e_end = $gff_end;
    $tmp_gff = $tmp_gff."$contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id\n";
    if (exists $gff_byorfname{$orf_found}) {$gff_byorfname{$orf_found} = $gff_byorfname{$orf_found}."@".$tmp_gff."@".$start_sad_polya_count;} else {$gff_byorfname{$orf_found} = $tmp_gff."@".$start_sad_polya_count;}
    #
    #
    
    
    
    
    
    
    #end of the while loop looking at each transcript to see what it contains
    }
    foreach $key (keys %start_sad_polya_hash_count){
        $hash_count_len = length $start_sad_polya_hash_count{$key};
        if ($hash_count_len < ($current_count - 3)) {
            $start_sad_polya_hash{$key} = $start_sad_polya_hash{$key}."\t"."."."\t"."."."\t"."."."\t"."Y";
            $start_sad_polya_hash_count{$key} = $start_sad_polya_hash_count{$key}."+";
        }
    }
    

    
    
    
close INCOUNT;
$current_count ++;
} #endwhile for going through the files list


open (OUT, ">$prefix.combined_counts_and_feature_names.txt");
print OUT "$title\n";
foreach $key (keys %start_sad_polya_hash){
    print OUT $key."\t".$start_sad_polya_hash{$key}."\t".$start_sad_polya_feature_list{$key}."\n";
}

open (OUTB, ">$prefix.count_of_translated_features.txt");
print OUTB "Feature\tCount\tPercent of total\tAverage poly A length of the dominant transcript\tCommand line is $command_line\n";
$feature_total = 0;
foreach $key (sort { $features_proteins_count{$b} <=> $features_proteins_count{$a} } keys %features_proteins_count){
    $feature_total = $feature_total + $features_proteins_count{$key};
}
print OUTB "Total of all features\t$feature_total\n";
foreach $key (sort { $features_proteins_count{$b} <=> $features_proteins_count{$a} } keys %features_proteins_count){
    $percent = (int (($features_proteins_count{$key} / $feature_total) * 1000000) / 10000);
   
    print OUTB $key."\t".$features_proteins_count{$key}."\t".$percent."\t"."$features_polya_len{$key}\n";
    
}

foreach $key (keys %features_proteins){
    $name = $features_proteins{$key};
    if (exists $features_proteins_count{$name}) {next;} else {print OUTB $name."\tNot found\n";}
}

open (GFF, ">$prefix.most_abundant_trans_per_orf.gff");
mkdir "$prefix";
chdir "$prefix";
foreach $key (keys %gff_byorfname){
    $possible = index ($key, "Possible");
    $second_m = index ($key, "2nd_M");
    $none_from = index ($key, "none from");
    %gff_tmp = ();
    $value = $gff_byorfname{$key};
    #print "$value\n\n";
    @array = split('@', $value);
    while (scalar @array > 0)
    {
        $gff_line = shift @array;
        #print "XXX \n$gff_line\n";exit;
        $gff_count = shift @array;
        $gff_tmp{$gff_line} = $gff_count;
    }
    $tmp_count = 0;
    foreach $keytwo (sort {$gff_tmp{$b} <=> $gff_tmp{$a} } keys %gff_tmp){
        
        $loc_a = index ($keytwo, "color=") + 5;
        $loc_b = index ($keytwo, ";Features=");
        $loc_offset = $loc_b - $loc_a;
        
        if ($tmp_count < 1) {
            if (($possible < 0) and ($second_m < 0) and ($none_from < 0)) {print GFF "$keytwo\n";}
            open (TMP, ">$prefix.$key.gff");
            $loc_a = index ($keytwo, "color=") + 5;
            $loc_b = index ($keytwo, ";Features=");
            $loc_offset = $loc_b - $loc_a;
            
            $new  = substr ($keytwo, $loc_a, $loc_offset, '=255,50,50');
          
        }
        if (($tmp_count > 0) and ($gff_tmp{$keytwo} == 1)){
            $new  = substr ($keytwo, $loc_a, $loc_offset, '=200,200,200');
        }
        print TMP "$keytwo\n";
        $tmp_count ++;
    }
    close TMP;
}


foreach $key (keys %kozac_list){
    print OUTKOZAC "$key\t$kozac_list{$key}\n";
    @k_array = split //, $kozac;
    
}
foreach $key (keys %splice_ad){
    print OUTSPLICESAD "$key\t$splice_ad{$key}\n"
}


exit;


sub translate
{
    $start = 0;
   
    $steps_from_start = 0;
    $new_peptide = "";
    $current_orf = "";
    $aa = "";
    $step = 1;
    $orf_start = 0;
    $orf_end = 0;
    $stop = "*";
    $lct = length ($current_transcript);
    #print "translate $lct $start $steps_from_start\n";
    #print OUTC "In translation $key  start ofset is $start\n";
    #
    while (($start + $steps_from_start) < $lct)
    {
        $next_codon_for = substr($current_transcript, ($start + $steps_from_start), 3);
        $aa = $translate_now{$next_codon_for};
       
        #print "$aa";
        if (($aa eq "M") and ($stop eq "*"))
        {
            $stop = "M";
            $step = 3;
            $kozac = substr($current_transcript, ($start + $steps_from_start - 6), 9);
            @k_array = split //, $kozac;
            $k_join = join ("\t", @k_array);
            $kozac = $kozac."\t".$k_join;
            $kozac = $k_join;
        }
        if ($aa eq "*" and ($stop eq "M")) {
            $stop = "END";
            $start = $lct + 100;
            last;
        }
        if ($stop eq "M") {$new_peptide = $new_peptide.$aa;}
        
        $steps_from_start = $steps_from_start + $step;
        
        
    }
 
    #if ($stop ne "END") {$new_peptide = "out of transcript";}
    #print OUTC "$key current orf at the end $current_orf\n";
    return $new_peptide;
}


sub translatesecond
{
    $start = 0;
    
    $steps_from_start = 0;
    $second_peptide = "";
    $current_orf = "";
    $aa = "";
    $step = 1;
    $orf_start = 0;
    $orf_end = 0;
    $stop = "*";
    $lct = length ($current_transcript);
    #print "translate $lct $start $steps_from_start\n";
    #print OUTC "In translation $key  start ofset is $start\n";
    #
    while (($start + $steps_from_start) < $lct)
    {
        $next_codon_for = substr($current_transcript, ($start + $steps_from_start), 3);
        $aa = $translate_now{$next_codon_for};
        if (($aa eq "M") and ($stop eq "M"))
        {
            $stop = "MM";
            $step = 3;
            
        }
        #print "$aa";
        if (($aa eq "M") and ($stop eq "*"))
        {
            $stop = "M";
            
        }
  
        
        if ($aa eq "*" and ($stop eq "MM")) {
            $stop = "END";
            $start = $lct + 100;
            last;
        }
        if ($stop eq "MM") {$second_peptide = $second_peptide.$aa;}
        
        $steps_from_start = $steps_from_start + $step;
        
        
    }
    
    if ($stop ne "END") {$new_peptide = "out of transcript";}
    #print OUTC "$key current orf at the end $current_orf\n";
    return $second_peptide;
}
