#!/bin/zsh

# Process: Do the whole process from minimap_W0_Matthews

# cd ~/OneDrive\ -\ Imperial\ College\ London/_Data/RNA-seq-robOnedrive/Nanopore_RNA-seq/
# permissions with chmod u+x _Paper_analysis/vs_WTw_output/Paper_AllvsWTwv2_part1.sh
# run with ./_Paper_analysis/vs_WTw_output/Paper_AllvsWTwv2_part1.sh

# Here all relevant input files should be in the folder in the cd line above:
#     EBV_annotations; Guppy_6_output (fastq) ; EBV_FAST5; Aaron_script

#can be adapted by replacing AllvsWTw (or tag marked beow)
# rename destination files in communal folders to avoid overwriting read files: EBV_Fast5 -> EBV_Fast5;  EBV_readIDs -> EBV_readIDs
# Folders required from run directory: ./Guppy_6_output containing fastq; EBV_Fast5 containing fast5; SAM_files; SAM_unq; Matthews _script containing two Matthews perl scripts; Aaron_script containing three W0 R scripts; W0_SAM containing folders W0_first, 

#Concatenate original fastq reads into single file for mapping.

# to prepare a new run: copy _Paper_analysis/vs_WTw_output_empty to new folder, and mkdir _Paper_analysis/vs_WTw_output/SAM_files 

#cat  ./Guppy_6_output/AllFASTq/* > ./Guppy_6_output/Guppy6_Allpassreads.fastq.gz

# first map reads. Fasta: WTw_oriPMlu.fa reads: ./Guppy_6_output/AllFASTq ; tag: AllvsWTw
#alternative is align to self separately, and then concatenate the SAM files. 
# minimap2 -ax splice -uf -k14  --junc-bed EBV_annotations/EBV_annotations_paper/pHB9_2023v1.bed EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa ./Guppy_6_output/Guppy6_Allpassreads.fastq.gz > _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw.sam

# switch to oriP_Mlu template, need to change: _Paper_analysis/vs_WTw_output change to _Paper_analysis/vs_WTw_output
# change annotation files to new numbers: EBNAexons_pHB9_oriPMlu.bed -> EBNAexons_pHB9_oriPMlu.bed ; Features_table_pHB9_oriPMlu.txt -> Features_table_pHB9_oriPMlu.txt WTw_oriPMlu.fa -> WTw_oriPMlu.fa; WTw_oriPMlu.fa -> WTw_oriPMlu.fa WTw_2023.fa -> WTw_oriPMlu.fa ; MR11_noATG.fa ->  MR11_noATG ;  pHB9_oriPMluv4.bed -> pHB9_oriPMluv4.bed (made with agat_convert_sp_gff2bed.pl --gff EBV_annotations/pHB9_oriPMluv3.gff3 -o EBV_annotations/pHB9_oriPMluv4.bed)


mkdir ./_Paper_analysis/vs_WTw_output/SAM_files
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM
mkdir ./_Paper_analysis/vs_WTw_output/SAM_unq
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_ends_not_assigned
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length
# mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_transcript_variation
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_5p_intact
mkdir ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_3p_intact
mkdir ./_Paper_analysis/vs_WTw_output/Matthews_script
mkdir ./_Paper_analysis/vs_WTw_output/Matthews_script/Script_out
mkdir ./_Paper_analysis/vs_WTw_output/Matthews_script/Nanopolish 

# align reads to EBV genome. Guided by annotaiton and splice junction consensus rules.

minimap2 -ax splice -uf -k14 --junc-bed EBV_annotations/EBV_annotations_paper/pHB9_oriPMluv4.bed EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa ./Guppy_6_output/HB9/HB9_Guppy6_Allpassreads.fastq.gz > _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.sam

minimap2 -ax splice -uf -k14 --junc-bed EBV_annotations/EBV_annotations_paper/pHB9_oriPMluv4.bed EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa ./Guppy_6_output/WTw-A11/WTw_Guppy6_Allpassreads.fastq.gz > _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.sam

minimap2 -ax splice -uf -k14 --junc-bed EBV_annotations/EBV_annotations_paper/pHB9_oriPMluv4.bed EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa ./Guppy_6_output/M11-AJ2/M11-AJ2_Guppy6_Allpassreads.fastq.gz > _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.sam

minimap2 -ax splice -uf -k14 --junc-bed EBV_annotations/EBV_annotations_paper/pHB9_oriPMluv4.bed EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa ./Guppy_6_output/M11-MJ2/M11-MJ2_Guppy6_Allpassreads.fastq.gz > _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.sam


samtools view -b _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.sam > _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.bam 
samtools view -F 0x04 -b _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.bam > _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw_mapped.bam
samtools sort _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw_mapped.bam > _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw_sort.bam 
samtools index -b _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw_sort.bam
echo " Mapped reads in HB9="
# remove secondary alignments and other QC-failures
# the xxx_sort.bam file is the main input file for later steps
samtools view -c -F 260 _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw_sort.bam 
# number is 635
# make list of fastq IDs for later splitting merged file
samtools view _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.sam | cut -f 1 > ./Guppy_6_output/HB9vsWTwEBV_readIDs.txt


samtools view -b _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.sam > _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.bam 
samtools view -F 0x04 -b _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.bam > _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw_mapped.bam
samtools sort _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw_mapped.bam > _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw_sort.bam 
samtools index -b _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw_sort.bam
echo " Mapped reads in WTw="
samtools view -c -F 260 _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw_sort.bam
# number is 1637 - can be 1638
# make list of fastq IDs for later splitting merged file
samtools view _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.sam | cut -f 1 > ./Guppy_6_output/WTwvsWTwEBV_readIDs.txt

samtools view -b _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.sam > _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.bam 
samtools view -F 0x04 -b _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.bam > _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw_mapped.bam
samtools sort _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw_mapped.bam > _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw_sort.bam 
samtools index -b _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw_sort.bam
echo " Mapped reads in M11-AJ2="
samtools view -c -F 260 _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw_sort.bam
# number is 516
# make list of fastq IDs for later splitting merged file
samtools view _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.sam | cut -f 1 > ./Guppy_6_output/M11-AJ2vsWTwEBV_readIDs.txt

samtools view -b _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.sam > _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.bam 
samtools view -F 0x04 -b _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.bam > _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw_mapped.bam
samtools sort _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw_mapped.bam > _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw_sort.bam 
samtools index -b _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw_sort.bam
echo " Mapped reads in M11-MJ2="
samtools view -c -F 260 _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw_sort.bam
# number is 907
# make list of fastq IDs for later splitting merged file
samtools view _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.sam | cut -f 1 > ./Guppy_6_output/M11-MJ2vsWTwEBV_readIDs.txt

# Merge read IDs intot total EBV read ID list.

cat ./Guppy_6_output/M11-MJ2vsWTwEBV_readIDs.txt ./Guppy_6_output/M11-AJ2vsWTwEBV_readIDs.txt ./Guppy_6_output/WTwvsWTwEBV_readIDs.txt ./Guppy_6_output/HB9vsWTwEBV_readIDs.txt > ./Guppy_6_output/AllvsWTwEBV_readIDs.txt


# removes all of the intermediate files, including the orignal SAM file. 
rm _Paper_analysis/vs_WTw_output/SAM_files/*_mapped.bam
#rm _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.sam
#rm _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.sam
rm _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw.bam
rm _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw.bam
rm _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.bam
#rm _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw.sam
rm _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.bam
#rm _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw.sam



# merge the four separate BAM files into a single BAM file add -f to force file overwrite. merge is expected to produce sorted bam.
samtools merge -f _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_sort.bam _Paper_analysis/vs_WTw_output/SAM_files/M11-MJ2vsWTw_sort.bam _Paper_analysis/vs_WTw_output/SAM_files/M11-AJ2vsWTw_sort.bam _Paper_analysis/vs_WTw_output/SAM_files/WTwvsWTw_sort.bam _Paper_analysis/vs_WTw_output/SAM_files/HB9vsWTw_sort.bam
samtools index -b _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_sort.bam

#report mapped reads
echo " Mapped reads in AllvsWTw="
#Output - Mapped reads in AllvsWTw=3707 - currently is 3695
#remove duplicates and AQC fails - should not be required
samtools view -c -F 260 _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_sort.bam

# converts sorted file back to sam with header - I dont think we need this.
# samtools view -h _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_sort.bam > _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_sort.sam

# delete no-longer needed files - retain only sorted and mapped files (suffix _sort.bam).
# rm _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw.sam
# rm _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw.bam
# rm _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_mapped.bam


#Now make headered and headerless unique read files for Aaron script, and transfer to MAtthews script

samtools view -F 2304 -b _Paper_analysis/vs_WTw_output/SAM_files/AllvsWTw_sort.bam > _Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.bam
samtools index -b _Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.bam

#report mapped reads
echo " Mapped Unique reads in AllvsWTw = "
samtools view -c -F 260 _Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.bam
#Output - Mapped unique reads should be 3693

#Convert to headered SAM for later
samtools view -h ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.bam > ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.sam

# trim columns from the end of the file and saves as header-less SAM. 
# samtools view ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.sam | cut -f 1-10 > ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq_trim.sam

#Cd /Volumes/PC_EXTERNAL/RNAseq_minION-fast5_Guppy-fastq/Bristol-RNAseq
#command calls the fast5 folder that is here. 
#mkdir /Users/rew/Library/CloudStorage/OneDrive-ImperialCollegeLondon/_Data/RNA-seq-robOnedrive/Nanopore_RNA-seq/EBV_Fast5
#fast5_subset --input /Volumes/PC_EXTERNAL/RNAseq_minION-fast5_Guppy-fastq/Bristol-RNAseq/fast5 --save_path /Users/rew/Library/CloudStorage/OneDrive-ImperialCollegeLondon/_Data/RNA-seq-robOnedrive/Nanopore_RNA-seq/EBV_Fast5 --read_id_list /Users/rew/Library/CloudStorage/OneDrive-ImperialCollegeLondon/_Data/RNA-seq-robOnedrive/Nanopore_RNA-seq/Guppy_6_output/AllvsWTwEBV_readIDs.txt --batch_size 100 --recursive

